----------------------------------------------------------------------------------------------------------------------
-- @date: 		Initial Release Unknown
-- @history: 	Unknown
-- @author:		Unknown
-- @version     1.4a    --  EditDate 09.06.2018 Edit by Ahran Modding
-- @version: 	1.4 	-- 	EditDate 03.06.2017 Edit by Marc-Modding & Blacky_BPG
-- @version: 	1.3a 	-- 	Convert to FS17 / EditDate 27.05.2017 Edit by Marc-Modding & Blacky_BPG
-- @version: 	1.1 	-- 	Convert to FS15 / EditDate 20.02.2016 Edit by Marc-Modding & Blacky_BPG

----------------------------------------------------------------------------------------------------------------------

--MODDESC Entries:
--<specialization name="LuefterSound" 			className="LuefterSound" 			filename="XXX/LuefterSound.lua"/>
--<vehicleTypes> 
--<type name="XXX" className="" filename="$dataS/scripts/vehicles/Vehicle.lua"> 
--<specialization name="LuefterSound"/> 
--</type> 
--</vehicleTypes>
--
--
--XML Entries:	
--<fanSound file="" pitchOffset="" volume="" radius="" innerRadius=""/>
--
----------------------------------------------------------------------------------------------------------------------


DisplayBoot = {}
DisplayBoot.modDir = g_currentModDirectory
function DisplayBoot.prerequisitesPresent(specializations) return true end
function DisplayBoot:load(savegame)
	self.speedWaitingMaxTimeHud = 1400
	self.speedWaitingTimerBoot = 0
	self.bootScreen = 1
	local bootTime = 0
	if hasXMLProperty(self.xmlFile,"vehicle.bootLoader") then
		self.bootLoader = {}
		self.speedWaitingMaxTimeHud = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.bootLoader#defaultTime"),self.speedWaitingMaxTimeHud)
		local i = 0;
		while true do
			local key = string.format("vehicle.bootLoader.screen(%d)",i)
			if not hasXMLProperty(self.xmlFile, key) then
				break
			end
			i = i + 1
			self.bootLoader[i] = {}
			self.bootLoader[i].wasSet = false
			self.bootLoader[i].time = math.max(Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#showTime"),self.speedWaitingMaxTimeHud),60) + bootTime
			self.bootLoader[i].stayOn = Utils.getNoNil(getXMLBool(self.xmlFile, key.."#stayOn"),false)
			bootTime = self.bootLoader[i].time
			local screen = getXMLString(self.xmlFile, key.."#index")
			if screen ~= nil then
				self.bootLoader[i].screen = Utils.indexToObject(self.components, screen)
				setVisibility(self.bootLoader[i].screen, false)
			end
			local other = getXMLString(self.xmlFile, key.."#other")
			if other ~= nil then
				self.bootLoader[i].other = Utils.indexToObject(self.components, other)
				setVisibility(self.bootLoader[i].other, false)
			end
			local sound = getXMLString(self.xmlFile, key.."#sound")
			if sound ~= nil then
				self.bootLoader[i].sound = Utils.indexToObject(self.components, sound)
				setVisibility(self.bootLoader[i].sound, false)
			end
			local soundFile = getXMLString(self.xmlFile, key.."#soundFile")
			if soundFile ~= nil then
				self.bootLoader[i].soundSample = createSample("screen"..i.."Sample")
				local fileName = Utils.getFilename(soundFile, DisplayBoot.modDir)
				loadSample(self.bootLoader[i].soundSample, fileName, false)
			end
		end
	end
	self.soundAdj = {};
	local i=0;
    while true do
        local key = string.format("vehicle.indoorsoundAdjustment.animation(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local animName = getXMLString(self.xmlFile, key.."#name");
        local lowpassGain = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#lowpassGain"), 0.5);
        local volumeFactor = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#volumeFactor"), 0.5);
		self.soundAdj[i] = {};
		self.soundAdj[i].animName = animName;
		self.soundAdj[i].volumeFactor = volumeFactor;
		self.soundAdj[i].lowpassGain = lowpassGain;
        i = i +1;
    end;
	
	if self.isClient then
		self.sampleOpenDoorleftDoor = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "sounds/tuer_auf.wav", self.baseDirectory, self.components[1].node);
		self.sampleCloseDoorleftDoor = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "sounds/tuer_zu2.wav", self.baseDirectory, self.components[1].node);
		self.sampleOpenDoorrightDoor = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "sounds/tuer_auf.wav", self.baseDirectory, self.components[1].node);
		self.sampleCloseDoorrightDoor = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "sounds/tuer_zu2.wav", self.baseDirectory, self.components[1].node);
		self.sampleOpenbackWindow = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "sounds/tuer_auf.wav", self.baseDirectory, self.components[1].node);
		self.sampleClosebackWindow = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "sounds/tuer_zu2.wav", self.baseDirectory, self.components[1].node);
		self.sampleOpenroof = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "sounds/tuer_auf.wav", self.baseDirectory, self.components[1].node);
		self.sampleCloseroof = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "sounds/tuer_zu2.wav", self.baseDirectory, self.components[1].node);
	end;
end

function DisplayBoot:update(dt)
	if self.isMotorStarted then
		if self.bootLoader ~= nil then
			if self.bootLoader[self.bootScreen] ~= nil then
				if self.speedWaitingTimerBoot < self.bootLoader[self.bootScreen].time then
					if not self.bootLoader[self.bootScreen].wasSet then
						if self.bootLoader[self.bootScreen].screen ~= nil then
							setVisibility(self.bootLoader[self.bootScreen].screen, true)
						end
						if self.bootLoader[self.bootScreen].other ~= nil then
							setVisibility(self.bootLoader[self.bootScreen].other, true)
						end
						if g_currentMission.controlledVehicle == self and self.activeCamera.isInside then
							if self.bootLoader[self.bootScreen].sound ~= nil then
								setVisibility(self.bootLoader[self.bootScreen].sound, true)
							end
							if self.bootLoader[self.bootScreen].soundSample ~= nil then
								playSample(self.bootLoader[self.bootScreen].soundSample, 1, 1, 0)
							end
						end
						self.bootLoader[self.bootScreen].wasSet = true
					end
				else
					if self.speedWaitingTimerBoot >= self.bootLoader[self.bootScreen].time then
						if self.bootLoader[self.bootScreen].wasSet then
							if not self.bootLoader[self.bootScreen].stayOn then
								if self.bootLoader[self.bootScreen].screen ~= nil then
									setVisibility(self.bootLoader[self.bootScreen].screen, false)
								end
								if self.bootLoader[self.bootScreen].other ~= nil then
									setVisibility(self.bootLoader[self.bootScreen].other, false)
								end
								if self.bootLoader[self.bootScreen].sound ~= nil then
									setVisibility(self.bootLoader[self.bootScreen].sound, false)
								end
								if self.bootLoader[self.bootScreen].soundSample ~= nil then
									stopSample(self.bootLoader[self.bootScreen].soundSample)
								end
							end
							self.bootLoader[self.bootScreen].wasSet = false
						end
						self.bootScreen = self.bootScreen + 1
					end
				end
			end
		end
		self.speedWaitingTimerBoot = self.speedWaitingTimerBoot + dt
	else
		for i=1, table.getn(self.bootLoader) do
			if self.bootLoader[i] ~= nil then
				if self.bootLoader[i].screen ~= nil then
					setVisibility(self.bootLoader[i].screen, false)
				end
				if self.bootLoader[i].other ~= nil then
					setVisibility(self.bootLoader[i].other, false)
				end
				if self.bootLoader[i].sound ~= nil then
					setVisibility(self.bootLoader[i].sound, false)
				end
				if self.bootLoader[i].soundSample ~= nil then
					stopSample(self.bootLoader[i].soundSample)
				end
				self.bootLoader[i].wasSet = false
			end
		end
		self.speedWaitingTimerBoot = 0
		self.bootScreen = 1
	end
	if self:getIsActive() and self.isClient then
		if self.isEntered then
			if self:getIsActiveForSound() then
				if self:getIsAnimationPlaying("leftDoor") then
					if self.animations["leftDoor"].currentSpeed > 0 and self.animations["leftDoor"].currentTime < 100 then
						if not SoundUtil.isSamplePlaying(self.sampleOpenDoorleftDoor, 1.5*dt) then
							SoundUtil.playSample(self.sampleOpenDoorleftDoor,1,1,nil);
						end;
					elseif self.animations["leftDoor"].currentSpeed < 0 and self.animations["leftDoor"].currentTime < 100 then
						if not SoundUtil.isSamplePlaying(self.sampleCloseDoorleftDoor, 1.5*dt) then
							SoundUtil.playSample(self.sampleCloseDoorleftDoor,1,1,nil);
						end;
					end;
				else
					if SoundUtil.isSamplePlaying(self.sampleOpenDoorleftDoor) then	
						stopSample(self.sampleOpenDoorleftDoor.sample);
					end;
				end;
				
				if self:getIsAnimationPlaying("rightDoor") then
					if self.animations["rightDoor"].currentSpeed > 0 and self.animations["rightDoor"].currentTime < 100 then
						if not SoundUtil.isSamplePlaying(self.sampleOpenDoorrightDoor, 1.5*dt) then
							SoundUtil.playSample(self.sampleOpenDoorrightDoor,1,1,nil);
						end;
					elseif self.animations["rightDoor"].currentSpeed < 0 and self.animations["rightDoor"].currentTime < 100 then
						if not SoundUtil.isSamplePlaying(self.sampleCloseDoorrightDoor, 1.5*dt) then
							SoundUtil.playSample(self.sampleCloseDoorrightDoor,1,1,nil);
						end;
					end;
				else
					if SoundUtil.isSamplePlaying(self.sampleOpenDoorrightDoor) then	
						stopSample(self.sampleOpenDoorrightDoor.sample);
					end;
				end;
				
				if self:getIsAnimationPlaying("backWindow") then
					if self.animations["backWindow"].currentSpeed > 0 and self.animations["backWindow"].currentTime < 100 then
						if not SoundUtil.isSamplePlaying(self.sampleOpenbackWindow, 2.5*dt) then
							SoundUtil.playSample(self.sampleOpenbackWindow,1,1,nil);
						end;
					elseif self.animations["backWindow"].currentSpeed < 0 and self.animations["backWindow"].currentTime < 100 then
						if not SoundUtil.isSamplePlaying(self.sampleClosebackWindow, 2.5*dt) then
							SoundUtil.playSample(self.sampleClosebackWindow,1,1,nil);
						end;
					end;
				else
					if SoundUtil.isSamplePlaying(self.sampleOpenbackWindow) then	
						stopSample(self.sampleOpenbackWindow.sample);
					end;
				end;
				
				if self:getIsAnimationPlaying("roof") then
					if self.animations["roof"].currentSpeed > 0 and self.animations["roof"].currentTime < 100 then
						if not SoundUtil.isSamplePlaying(self.sampleOpenroof, 1.5*dt) then
							SoundUtil.playSample(self.sampleOpenroof,1,1,nil);
						end;
					elseif self.animations["roof"].currentSpeed < 0 and self.animations["roof"].currentTime < 100 then
						if not SoundUtil.isSamplePlaying(self.sampleCloseroof, 1.5*dt) then
							SoundUtil.playSample(self.sampleCloseroof,1,1,nil);
						end;
					end;
				else
					if SoundUtil.isSamplePlaying(self.sampleOpenroof) then	
						stopSample(self.sampleOpenroof.sample);
					end;
				end;
				
				local sound=false;
				for i=0, #self.soundAdj do
					if self.animations[self.soundAdj[i].animName] ~= nil and self.animations[self.soundAdj[i].animName].currentTime > 500 then
						self.sampleMotor.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotor.indoorVolumeFactor);
						self.sampleMotor.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotor.indoorLowpassGain);
						self.sampleMotorStart.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorStart.indoorVolumeFactor);
						self.sampleMotorStart.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorStart.indoorLowpassGain);
						self.sampleMotorStop.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorStop.indoorVolumeFactor);
						self.sampleMotorStop.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorStop.indoorLowpassGain);
						
						self.sampleMotorRun.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorRun.indoorVolumeFactor);
						self.sampleMotorRun.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorRun.indoorLowpassGain);
						self.sampleMotorLoad.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorLoad.indoorVolumeFactor);
						self.sampleMotorLoad.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorLoad.indoorLowpassGain);
						sound=true;
					else
						if not sound then
							self.sampleMotor.indoorVolumeFactor = 0.55;
							self.sampleMotor.indoorLowpassGain = 0.2;
							self.sampleMotorStart.indoorVolumeFactor = 0.55;
							self.sampleMotorStart.indoorLowpassGain = 0.2;
							self.sampleMotorStop.indoorVolumeFactor = 0.55;
							self.sampleMotorStop.indoorLowpassGain = 0.2;
							
							self.sampleMotorRun.indoorVolumeFactor = 0.7;
							self.sampleMotorRun.indoorLowpassGain = 0.4;
							self.sampleMotorLoad.indoorVolumeFactor = 0.7;
							self.sampleMotorLoad.indoorLowpassGain = 0.4;
						end;
					end;
				end;
			end;
			SoundUtil.onCameraSwitched(self.activeCamera.isInside);
		end;
    end;
end

function DisplayBoot:delete()
	if self.bootLoader ~= nil then
		for i=1, table.getn(self.bootLoader) do
			if self.bootLoader[i] ~= nil and self.bootLoader[i].soundSample ~= nil then
				stopSample(self.bootLoader[i].soundSample)
				delete(self.bootLoader[i].soundSample)
			end
		end
	end
	if self.sampleOpenDoorleftDoor ~= nil then
		SoundUtil.deleteSample(self.sampleOpenDoorleftDoor);
	end;
	if self.sampleOpenDoorrightDoor ~= nil then
		SoundUtil.deleteSample(self.sampleOpenDoorrightDoor);
	end;
	if self.sampleOpenbackWindow ~= nil then
		SoundUtil.deleteSample(self.sampleOpenbackWindow);
	end;
	if self.sampleOpenroof ~= nil then
		SoundUtil.deleteSample(self.sampleOpenroof);
	end;
	if self.sampleCloseDoorleftDoor ~= nil then
		SoundUtil.deleteSample(self.sampleCloseDoorleftDoor);
	end;
	if self.sampleCloseDoorrightDoor ~= nil then
		SoundUtil.deleteSample(self.sampleCloseDoorrightDoor);
	end;
	if self.sampleClosebackWindow ~= nil then
		SoundUtil.deleteSample(self.sampleClosebackWindow);
	end;
	if self.sampleCloseroof ~= nil then
		SoundUtil.deleteSample(self.sampleCloseroof);
	end;
end

function DisplayBoot:getSaveAttributesAndNodes(nodeIdent) end
function DisplayBoot:updateTick(dt) end
function DisplayBoot:draw() end
function DisplayBoot:mouseEvent(posX, posY, isDown, isUp, button) end
function DisplayBoot:keyEvent(unicode, sym, modifier, isDown) end
function DisplayBoot:onAttach(attacherVehicle, jointDescIndex) end
function DisplayBoot:onDetach() end
function DisplayBoot:onDeactivate() end

LuefterSound = {}
LuefterSound.modDir = g_currentModDirectory

function LuefterSound.prerequisitesPresent(specializations) return true end

function LuefterSound:load(savegame)
      local fanSound = getXMLString(self.xmlFile, "vehicle.fanSound#file")
        if fanSound ~= nil and fanSound ~= "" then
            fanSound = Utils.getFilename(fanSound, self.baseDirectory)
			self.fanSound = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.fanSound", nil, LuefterSound.modDir, self.components[1].node)
            self.fanSoundVolume = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.fanSound#volume"), 0.7) --Lautstaerke des Soundfiles wenn nicht in XML definiert
            self.fanSoundTime = 29999 --Laenge des FanSoundFiles in ms
            self.startTime = 1
            self.startTimeDiff = 10000 --Dauer bis das Soundfile agespielt wird
            self.stopTime = 0
            self.fanSoundEnabled = false
      end
end

function LuefterSound:delete()         
     if self.fanSound ~= nil then
		SoundUtil.deleteSample(self.fanSound)
    end  
end

function LuefterSound:update(dt)     
    if self.isMotorStarted then 
        if self:getIsActiveForSound() and g_currentMission.controlledVehicle == self then
            if self.fanSound ~= nil then
                if self.fanSoundEnabled then
					self.stopTime = self.stopTime - dt
					if self.stopTime <= 0 then
						SoundUtil.stopSample(self.fanSound, true)
						self.fanSoundEnabled = false
					end
                end
                if not self.fanSoundEnabled and self.startTime < 1 then
					SoundUtil.playSample(self.fanSound,0,0,self.fanSoundVolume)
                    self.stopTime = self.fanSoundTime
                    self.fanSoundEnabled = true
                end
            end
        end
    else
-- Nachlauffunktion des Lüfters
-- wenn der Motor aus ist und der Lüfter läuft dann wird dieser nach der normalen Zeit erst abgeschaltet
        if self:getIsActiveForSound() and g_currentMission.controlledVehicle == self then
            if self.fanSound ~= nil then
                if self.fanSoundEnabled then
					self.stopTime = self.stopTime - dt
					if self.stopTime <= 0 then
						SoundUtil.stopSample(self.fanSound, true)
						self.fanSoundEnabled = false
					end
				end
			end
		end
    end
end

function LuefterSound:updateTick(dt)
	if self.isMotorStarted then
		if self.fanSound ~= nil then
			local mLoad = math.max(self.motor:getMotorLoad(),0.25)
			self.startTime = self.startTime + math.max((mLoad*mLoad),mLoad)
			if self.startTime > self.startTimeDiff then
				self.startTime = 0
			end
		end
	end
end

function LuefterSound:stopSounds()
    if self.isClient then
         if self.fanSoundEnabled then
              SoundUtil.stopSample(self.fanSound, true)
              self.fanSoundEnabled = false
         end
    end
end
function LuefterSound:onEnter()
    if self.isClient then
         if self.fanSoundEnabled then
              SoundUtil.playSample(self.fanSound,0,0,self.fanSoundVolume)
         end
    end
end
function LuefterSound:onLeave()
    if self.isClient then
         if self.fanSoundEnabled then
              SoundUtil.stopSample(self.fanSound, true)
         end
    end
end

function LuefterSound:startMotor() end
function LuefterSound:stopMotor() end
function LuefterSound:mouseEvent(posX, posY, isDown, isUp, button) end
function LuefterSound:keyEvent(unicode, sym, modifier, isDown) end
function LuefterSound:draw() end
